/*

    QBabbel, a simple VoIP chat utility using JVOIPLIB 
    Copyright (C) 2004  Jori Liesenborgs (jori@lumumba.luc.ac.be)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "qbabbelimpl.h"
#include <qapplication.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <iostream>

int main(int argc,char *argv[])
{
	QApplication app(argc,argv);
	int imul = 1;

	int numargs = app.argc();
	if (numargs < 3 || numargs > 4)
	{
		std::cerr << std::endl << "Usage: " << std::endl << std::endl;
		std::cerr << "qbabbel IP port [multiplier]" << std::endl << std::endl;
		exit(-1);
	}

	unsigned long ipaddr = inet_addr(app.argv()[1]);
	if (ipaddr == INADDR_NONE)
	{
		std::cerr << "Invalid IP address" << std::endl;
		exit(-1);
	}
	ipaddr = ntohl(ipaddr);
	int portbase;
	if (sscanf(app.argv()[2],"%d",&portbase) != 1)
	{
		std::cerr << "Invalid portbase" << std::endl;
		exit(-1);
	}

	if (numargs == 4)
	{
		if (sscanf(app.argv()[3],"%d",&imul) != 1)
		{
			std::cerr << "Invalid multiplier" << std::endl;
			exit(-1);
		}
		if (imul > 8 || imul < 1)
		{
			std::cerr << "Invalid multiplier)" << std::endl;
			exit(-1);
		}
	}
	
	QBabbelImpl dlg(ipaddr,(unsigned short)portbase,imul);

	app.setMainWidget(&dlg);
	dlg.show();
	return app.exec();
}
