/*

    QBabbel, a simple VoIP chat utility using JVOIPLIB 
    Copyright (C) 2004  Jori Liesenborgs (jori@lumumba.luc.ac.be)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef QBABBELIMPL_H

#define QBABBELIMPL_H

#include "qbabbel.h"
#include "qbabbelinput.h"
#include "qbabbeloutput.h"
#include <jvoipsession.h>

class QBabbelImpl : public QBabbel,public JVOIPSession
{
	Q_OBJECT

public:
	QBabbelImpl(unsigned long destip,unsigned short destport,int imul = 1) throw (JVOIPException);
	~QBabbelImpl() throw (JVOIPException);
private slots:
	void OnTimeout();
private:
	bool RegisterUserDefinedInput(JVOIPVoiceInput **i) { *i = &chatinput; return true; }
	bool RegisterUserDefinedOutput(JVOIPVoiceOutput **o) { *o = &chatoutput; return true; }
	QBabbelInput chatinput;
	QBabbelOutput chatoutput;
};

#endif // QBABBELIMPL_H

